import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStreamReader;

public class SplitTest{

	public void splitting(String arr_s, String regex) {

		String[] ary = arr_s.split(regex);

		for(int i=0;i<ary.length;i++){
			System.out.println("array["+i+"]\tlength("+ary[i].length()+")\t>"+ary[i]+"<");
		}

		//String regex = argv[1];
		if(regex.indexOf("\\")>=0){
			regex = regex.replaceAll("\\\\", "\\\\\\\\");
			System.out.println("\n\nYour delimiter expression contains at least one \\ character.\n"+
					"To prevent the java compiler interpreting this as an escape\n"+
					"code, you should use the following split() command in your \n.java sourcecode:\n\n"+
					"myString.split(\""+regex+"\");");
		}else{
			System.out.println("\n\nUse the following split() command in your .java sourcecode:\n\n"+
					"myString.split(\""+regex+"\");");
		}

		return;

	}

	public static void main(String[] argv){
		System.out.println("Usage: java SplitTest \"string to split\" \"regex to split by\"\n");

		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		String arr_s = null;
		String regex = null;
		String fileName = "test.txt";

		SplitTest sp = new SplitTest();
		boolean eclipse = true;

		try {	

			boolean console = false;

			while (true) {

				System.out.print ("Enter [1] to input a line of text from cmd.exe/WIN32_console\n" +
						"      [2] to read from a file (default: test.txt)(Eclipse's console)\n" +
				"      [3] to read from a file (default: test.txt)(cmd.exe/WIN32_console)\n>");

				String str = in.readLine();

				try { 

					if (1 == Integer.valueOf(str)) { 
						console = true;
						break;
					}

					else if (2 == Integer.valueOf(str)) {
						console = false;
						break;
					}

					else if (3 == Integer.valueOf(str))  {
						console = false;
						eclipse = false;
						break;
					}

					else {
						System.out.println("\nNot a valid choice, please re-try...");
					} 
				}

				catch (NumberFormatException n) {

					System.out.println("\nNot a valid choice, please re-try...");

				}

			}


			if (console) {
				System.out.print("\nInsert the string to be split as is and press ENTER\n>");

				arr_s = in.readLine();

				System.out.print("\nInsert the string to be used as regexp as is and press ENTER\n>");
				regex = in.readLine();
				sp.splitting(arr_s, regex);

			}

			else {

				System.out.print("\nInsert the string to be used as regexp as is and press ENTER\n>");
				regex = in.readLine();

				while (true) {
					try {

						if (null == fileName) {

							fileName = in.readLine();
						}

						BufferedReader in1 = null;

						if (null == fileName) break;

						if (eclipse) in1 = new BufferedReader(new FileReader("bin\\"+fileName));

						else in1 = new BufferedReader(new FileReader(fileName));

						while (true ) {

							String line1 = in1.readLine();

							if (line1 == null) {
								break;
							}

							if (line1.equals("")) continue;

							System.out.println("\n\nWe are splitting: \n>" + line1 +
									"\nUsing this regular expression:\n>" +
									regex);

							sp.splitting(line1, regex);

						}
						break;
					}

					catch (FileNotFoundException f) {
						System.out.print ("\n<!!!!> The file \"" + fileName + "\" was not found...\n" +
								"\nPlease enter the desired .txt file name complete with extension \n(press CTRL+C " +
						"or the red button on Eclipse's console to exit this program):\n>");
						fileName = null;
					}

				}

			}

		}

		catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}


